package com.minsait.onesait.platform.plugin.configuration;

import java.util.Arrays;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.oauth2.config.annotation.web.configuration.AuthorizationServerConfigurerAdapter;
import org.springframework.security.oauth2.config.annotation.web.configurers.AuthorizationServerEndpointsConfigurer;
import org.springframework.security.oauth2.provider.token.TokenEnhancer;
import org.springframework.security.oauth2.provider.token.TokenEnhancerChain;

import com.minsait.onesait.platform.plugin.utils.PluginTokenEnhancer;

@Configuration
public class AuthorizationServerConfigurer extends AuthorizationServerConfigurerAdapter {

	@Override
	public void configure(AuthorizationServerEndpointsConfigurer endpoints) throws Exception {
		final TokenEnhancerChain chain = new TokenEnhancerChain();
		chain.setTokenEnhancers(Arrays.asList(endpoints.getTokenEnhancer(), pluginTokenEnhancer()));
		endpoints.tokenEnhancer(chain);
	}

	@Bean
	public TokenEnhancer pluginTokenEnhancer() {
		return new PluginTokenEnhancer();
	}
}
